﻿--[[
<-.(`-')                            _(`-')   (`-').->_  (`-')        (`-')  _(`-')    (`-')     (`-')  _  (`-'),---. 
 __( OO)   <-.       .->       .-> ( (OO ).->( OO)_  \-.(OO )  <-.   (OO ).-/( OO).-> ( OO).->  ( OO).-<-.(OO )|   | 
'-'---.\ ,--. ) (`-')----.(`-')----.\    .'_(_)--\_) _.'    \,--. )  / ,---. /    '._ /    '._ (,------,------,|   | 
| .-. (/ |  (`-'( OO).-.  ( OO).-.  '`'-..__/    _ /(_...--''|  (`-')| \ /`.\|'--...__|'--...__)|  .---|   /`. |   | 
| '-' `.)|  |OO ( _) | |  ( _) | |  |  |  ' \_..`--.|  |_.' ||  |OO )'-'|_.' `--.  .--`--.  .--(|  '--.|  |_.' |  .' 
| /`'.  (|  '__ |\|  |)|  |\|  |)|  |  |  / .-._)   |  .___.(|  '__ (|  .-.  |  |  |     |  |   |  .--'|  .   .`--'  
| '--'  /|     |' '  '-'  ' '  '-'  |  '-'  \       |  |     |     |'|  | |  |  |  |     |  |   |  `---|  |\  \.--.  
`------' `-----'   `-----'   `-----'`------' `-----'`--'     `-----' `--' `--'  `--'     `--'   `------`--' '--`--'  
By Kumartheffar a.k.a. Colin Firth
--]]

-- Settings
if hrate == nil then
    hrate = 2.5 -- Frequency of heart rate in seconds
end
if healththreshold == nil then
    healththreshold = 50 -- Health at which Heart Beat starts
end
if maxalpha == nil then
    maxalpha = 0.9 -- Maximum opacity of Blood Splatter.
end
if bltx == nil then
    bltx = 1 -- Blood Texture
end

Main = CreateFrame("Frame")
Main:RegisterEvent("PLAYER_LOGIN")
Main:RegisterEvent("PLAYER_LOGOUT")

-- Declare variables for which you care not of.
local totalb1 = 0 -- Beat 1 timer
local totalb2 = 0 -- Beat 2 timer
local totalbl = 0 -- Blood timer
local toggle = 0 -- Heart Beat toggle (so the sound only plays once)
local b1 = CreateFrame("frame") -- create the frame for the first beat events
local b2 = CreateFrame("frame") -- create the frame for the second beat events
local bl = CreateFrame("frame") -- create the frame for the blood splatter events

-- Creation of the Bloodsplatter graphical frame
BSF = CreateFrame("Frame", nil) -- Create the frame for the blood splatter image
BSF:SetFrameStrata("MEDIUM") -- set depth of frame
BSF:SetWidth(1024) -- Set width of image
BSF:SetHeight(1024) -- set height of image

-- Creation of the Bloodsplatter texture to be pasted on the Bloodsplatter frame
local BST = BSF:CreateTexture("Blood", "Background") -- Create texture for image and name it "blood"
BST:SetTexture("Interface\\AddOns\\Bloodsplatter\\Images\\Blood"..bltx..".tga") -- Load image texture
BST:SetAllPoints(BSF) -- ??? set points to the BSF Frame ???
BSF:SetPoint("CENTER") -- Set to center of screen?
BSF:SetAlpha(0) -- Set the initial alpha to 0 (invisible)
BSF:Show() -- Show the frame (even though it is invisible)

-- Heart Beat functions
local function beat1(self,elapsed)-- function to play 1st beat of heart
   totalb1 = totalb1 + elapsed -- Keep track of time passed
   if totalb1 >= UnitHealth("player")/UnitHealthMax("player")*hrate then -- Check to see if the elapsed time is greater than the desired heart rate
      if UnitHealth("player")/UnitHealthMax("player")*100 <= healththreshold and UnitHealth("player")/UnitHealthMax("player")*100 > 1 then -- Check to see if the player's health is less than the specified threshold and is also greater than 1%
         if toggle == 0 then -- check to see if toggle set by second beat has flipped or initial state which is also 0
            PlaySoundFile("Interface\\AddOns\\Bloodsplatter\\SFX\\heartbeat1.ogg", "Master") -- play 1st beat sound through Master volume setting
            toggle = 1 -- flip toggle so that the second beat will sound
         end
      end
   end
end

local function beat2(self,elapsed) -- function to play 2nd beat of heart
   totalb2 = totalb2 + elapsed -- Keep track of time passed
   if totalb2 >= UnitHealth("player")/UnitHealthMax("player")*hrate+hrate/10 then -- Check to see if the elapsed time is greater than the desired heart rate + 10% of the desired heart rate
      if UnitHealth("player")/UnitHealthMax("player")*100 <= healththreshold and UnitHealth("player")/UnitHealthMax("player")*100 > 1 then -- Check to see if the player's health is less than the specified threshold and is also greater than 1%
         if toggle == 1 then -- check to see if toggle set by first beat has flipped
            PlaySoundFile("Interface\\AddOns\\Bloodsplatter\\SFX\\heartbeat2.ogg", "Master") -- play 2nd beat sound through Master volume setting
            toggle = 0 -- flip toggle so that the first beat will sound again
         end
      end
      totalb2 = 0 -- reset timer of 2nd beat
      totalb1 = 0 -- reset timer of 1st beat
   end
end

-- Bloodsplatter function
local function blood(self,elapsed) -- Keep checking the players health and display blood if below threshold
   BST:SetTexture("Interface\\AddOns\\Bloodsplatter\\Images\\Blood"..bltx..".tga")
   local healthdec = UnitHealth("player")/UnitHealthMax("player") -- Set variable to store decimal of health 0.0 - 1.0
   if UnitHealth("player") >= 2 then -- If your health is above or equal to 2
      BSF:SetAlpha(maxalpha-(healthdec*(1/(healththreshold/100)))) -- magical formula to manage opacity of blood
   else -- otherwise, if your health is less than 2
      BSF:SetAlpha(0) -- Set blood to invisible.
   end
end

Main:SetScript("onEvent", function(self, event, ...) -- Run these 3 functions on event (PLAYER_LOGIN)
    SLASH_BSHEALTH1, SLASH_BSHEALTH2 = '/blsphr', '/bshr'
    local function bsplathr(arghr)
        if tonumber(arghr) == nil then
            print("|cffFF66CCYour heart will beat every  "..hrate.." seconds")
        else
            hrate = tonumber(arghr)
            print("|cffFF66CCHeart Rate set to "..hrate)
        end
    end
SlashCmdList["BSHEALTH"] = bsplathr
    SLASH_BSHEARTTHRESH1, SLASH_BSHEARTTHRESH2 = '/blspht', '/bsht'
        local function bsplatht(arght)
        if tonumber(arght) == nil then
            print("|cffFF66CCHeart will pump at "..healththreshold.."% Health")
        else
            healththreshold = tonumber(arght)
            print("|cffFF66CCHeath Threshold set to "..healththreshold)
        end
    end
SlashCmdList["BSHEARTTHRESH"] = bsplatht
    SLASH_BSTEX1, SLASH_BSTEX2 = '/blsptx', '/bstx'
        local function bsplattx(argtx)
        if tonumber(argtx) == nil or tonumber(argtx) < 0 or tonumber(argtx) > 5 then
            print("|cffFF0000You will see blood#"..bltx)
        else
            bltx = tonumber(argtx)
            print("|cffFF0000You will see blood#"..bltx)
        end
    end
SlashCmdList["BSTEX"] = bsplattx
SLASH_BSALPHA1, SLASH_BSALPHA2 = '/blspma', '/bsma'
        local function bsplatma(argma)
        if tonumber(argma) == nil or tonumber(argma) < 0 or tonumber(argma) > 100 then
            print("|cffFF0000Maximum Alpha is "..maxalpha*100)
        else
            maxalpha = tonumber(argma)/100
            print("|cffFF0000Maximum Alpha is "..maxalpha*100)
        end
    end
SlashCmdList["BSALPHA"] = bsplatma
    print("")
    print("|cffff0000Bloodsplatter: |cff9898981.0 |cffffffffLOADED :)")
    print("|cffFF66CCHeart Rate is |cffffffff"..hrate)
    print("|cffffff00Heart will pump at |cffffffff"..healththreshold.."|cffffff00% Health")
    print("|cffff0000Blood |cffffffffwill only show until |cff00cc00"..(maxalpha*100).."|cffffffff% Opacity")
    print("|cffffff00You are using Blood Texture |cffff0000#"..bltx)
	print("|cffFF0000Maximum Alpha is "..maxalpha*100)
    print("|cffff0000------------------------------------------------")
    print("|cff66CCFFUse: |cffFF9933/bshr <seconds> |cff66CCFFto change Heartrate")
    print("|cff66CCFFUse: |cffFF9933/bsht <percent> |cff66CCFFto change Health threshold")
    print("|cff66CCFFUse: |cffFF9933/bstx <1-5> |cff66CCFFto change Blood texture")
	print("|cff66CCFFUse: |cffFF9933/bsma <1-100> |cff66CCFFto change Maximum Opacity")
    print("")
    b1:SetScript("OnUpdate", beat1) -- First beat
    b2:SetScript("OnUpdate", beat2) -- Second beat
	bl:SetScript("OnUpdate", blood) -- Blood Splatter
end)